<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02600ContCorEstabelecimentoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getEstabelecParam ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, E.CDESTABELEC||' - '||E.NMESTABELEC AS LABELESTABELEC, E.CDEMPRESA, C.CDREDUCONT, B.CDBANCO, B.NMBANCO, 
                  B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                  FROM ESTABELECIMENTO E
                   LEFT JOIN CONTCORESTAB C
                    ON E.NRESTABELEC = C.NRESTABELEC
                    AND C.NRADQUIRENTE IS NULL
                    AND C.NRPRODUTOADQ IS NULL
                    LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                   FROM CONTCORR C 
                                   JOIN BANCO B
                                     ON C.CDBANCO = B.CDBANCO
                                    JOIN AGENCIA A
                                     ON C.CDAGENCIA = A.CDAGENCIA
                                     AND A.CDBANCO = B.CDBANCO)B
                      ON C.CDREDUCONT = B.CDREDUCONT
                 WHERE E.NRORG = :NRORG
                 AND UPPER (E.CDESTABELEC||' - '||E.NMESTABELEC||' - '||C.CDREDUCONT) LIKE UPPER (:LABELESTABELEC)
                 ORDER BY E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC";     
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEstabelecParamRow ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, E.CDEMPRESA, C.CDREDUCONT, B.CDBANCO, B.NMBANCO, 
                  B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                  FROM ESTABELECIMENTO E
                   JOIN CONTCORESTAB C
                    ON E.NRESTABELEC = C.NRESTABELEC
                    AND C.NRADQUIRENTE IS NULL
                    AND C.NRPRODUTOADQ IS NULL
                    LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                   FROM CONTCORR C 
                                   JOIN BANCO B
                                     ON C.CDBANCO = B.CDBANCO
                                    JOIN AGENCIA A
                                     ON C.CDAGENCIA = A.CDAGENCIA
                                     AND A.CDBANCO = B.CDBANCO)B
                      ON C.CDREDUCONT = B.CDREDUCONT
                 WHERE E.NRESTABELEC = :NRESTABELEC
                   AND E.NRORG       = :NRORG
                 ORDER BY E.NRESTABELEC";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getAdquirenteParam ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, A.NRADQUIRENTE, A.CDADQUIRENTE, A.NMADQUIRENTE, C.CDREDUCONT, B.CDBANCO, B.NMBANCO, 
                  B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                  FROM ADQUIRENTE A
                   LEFT JOIN CONTCORESTAB C
                    ON A.NRADQUIRENTE = C.NRADQUIRENTE
                    AND C.NRESTABELEC = :NRESTABELEC
                    AND C.NRPRODUTOADQ IS NULL
                    LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                   FROM CONTCORR C 
                                   JOIN BANCO B
                                     ON C.CDBANCO = B.CDBANCO
                                    JOIN AGENCIA A
                                     ON C.CDAGENCIA = A.CDAGENCIA
                                     AND A.CDBANCO = B.CDBANCO)B
                      ON C.CDREDUCONT = B.CDREDUCONT
                 WHERE A.NRORG = :NRORG
                 AND UPPER (A.NMADQUIRENTE||' - '||C.CDREDUCONT) LIKE UPPER (:LABELADQUIRENTE)
                 ORDER BY A.CDADQUIRENTE";     
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getAdquirenteParamRow ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, A.NRADQUIRENTE, A.CDADQUIRENTE, A.NMADQUIRENTE, C.CDREDUCONT, B.CDBANCO, B.NMBANCO, 
                  B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                  FROM ADQUIRENTE A
                   JOIN CONTCORESTAB C
                    ON A.NRADQUIRENTE = C.NRADQUIRENTE
                    AND C.NRESTABELEC = :NRESTABELEC
                    AND C.NRPRODUTOADQ IS NULL
                    LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                   FROM CONTCORR C 
                                   JOIN BANCO B
                                     ON C.CDBANCO = B.CDBANCO
                                    JOIN AGENCIA A
                                     ON C.CDAGENCIA = A.CDAGENCIA
                                     AND A.CDBANCO = B.CDBANCO)B
                      ON C.CDREDUCONT = B.CDREDUCONT
                 WHERE A.NRORG = :NRORG
                   AND A.NRADQUIRENTE = :NRADQUIRENTE
                 ORDER BY A.CDADQUIRENTE";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdAdqParam ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, P.NRPRODUTOADQ, P.CDPRODUTOADQ, P.NMPRODUTOADQ, C.CDREDUCONT, 
               B.CDBANCO, B.NMBANCO, B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                      FROM PRODUTOADQ P
                       LEFT JOIN CONTCORESTAB C
                        ON P.NRPRODUTOADQ = C.NRPRODUTOADQ
                        AND C.NRESTABELEC  = :NRESTABELEC
                        AND C.NRADQUIRENTE = :NRADQUIRENTE
                        LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                    A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                       FROM CONTCORR C 
                                       JOIN BANCO B
                                         ON C.CDBANCO = B.CDBANCO
                                        JOIN AGENCIA A
                                         ON C.CDAGENCIA = A.CDAGENCIA
                                         AND A.CDBANCO = B.CDBANCO)B
                          ON C.CDREDUCONT = B.CDREDUCONT
                     WHERE P.NRORG = :NRORG
                     AND UPPER (P.NMPRODUTOADQ||' - '||C.CDREDUCONT) LIKE UPPER (:LABELPRODUTOADQ)
                     ORDER BY P.NMPRODUTOADQ";     
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getProdutoAdqParamRow ($params) {
        $sql = "SELECT C.NRCONTCORESTAB, P.NRPRODUTOADQ, P.CDPRODUTOADQ, P.NMPRODUTOADQ, C.CDREDUCONT, 
               B.CDBANCO, B.NMBANCO, B.CDAGENCIA, B.NMAGENCIA, B.CDCONTCORR, B.DSCONTCORR
                      FROM PRODUTOADQ P
                       JOIN CONTCORESTAB C
                        ON P.NRPRODUTOADQ = C.NRPRODUTOADQ
                        AND C.NRESTABELEC  = :NRESTABELEC
                        AND C.NRADQUIRENTE = :NRADQUIRENTE
                        LEFT JOIN (SELECT C.CDBANCO, B.NMBANCO, C.CDAGENCIA, 
                                    A.NMAGENCIA, C.DSCONTCORR, C.CDCONTCORR, C.CDREDUCONT
                                       FROM CONTCORR C 
                                       JOIN BANCO B
                                         ON C.CDBANCO = B.CDBANCO
                                        JOIN AGENCIA A
                                         ON C.CDAGENCIA = A.CDAGENCIA
                                         AND A.CDBANCO = B.CDBANCO)B
                          ON C.CDREDUCONT = B.CDREDUCONT
                     WHERE P.NRORG = :NRORG
                  AND P.NRPRODUTOADQ = :NRPRODUTOADQ
                 ORDER BY P.CDPRODUTOADQ";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function insertContCorEstab ($params) {
        $sql = "INSERT INTO CONTCORESTAB
                  (NRCONTCORESTAB, NRESTABELEC, CDREDUCONT, NRORG)
                VALUES
                  (:NRCONTCORESTAB, :NRESTABELEC, :CDREDUCONT, :NRORG)";                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertContCorAdq ($params) {
        $sql = "INSERT INTO CONTCORESTAB
                  (NRCONTCORESTAB, NRESTABELEC, NRADQUIRENTE, CDREDUCONT, NRORG)
                VALUES
                  (:NRCONTCORESTAB, :NRESTABELEC, :NRADQUIRENTE, :CDREDUCONT, :NRORG)";                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertContCorProd ($params) {
        $sql = "INSERT INTO CONTCORESTAB
                  (NRCONTCORESTAB, NRESTABELEC, NRADQUIRENTE, NRPRODUTOADQ, CDREDUCONT, NRORG)
                VALUES
                  (:NRCONTCORESTAB, :NRESTABELEC, :NRADQUIRENTE, :NRPRODUTOADQ, :CDREDUCONT, :NRORG)";                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateContCorEstab($params) {
        $sql = "UPDATE CONTCORESTAB
                  SET CDREDUCONT = :CDREDUCONT
                WHERE NRCONTCORESTAB = :NRCONTCORESTAB";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deleteEstabelecContcor ($params) {
        $sql = "DELETE FROM CONTCORESTAB
                WHERE NRORG = :NRORG
                  AND NRCONTCORESTAB = :NRCONTCORESTAB";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function validateContCorEmpty ($params) {
        $sql = "SELECT NRCONTCORESTAB
                    FROM CONTCORESTAB  
                    WHERE NRORG = :NRORG  
                     AND NRCONTCORESTAB = :NRCONTCORESTAB";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getSeries ($params) {
        $sql = "SELECT DISTINCT CDINSCESTA, CDINSCMUNI, CDSERIE, DSSERIE  
                    FROM SERIENF  
                    WHERE NRORG = :NRORG  
                     AND CDINSCESTA = :CDINSCESTA  
                     AND CDINSCMUNI = :CDINSCMUNI  
                     AND CDEMPRESA = :CDEMPRESA  
                    ORDER BY CDSERIE";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEmpresaFilial ($params) {
        $sql = "SELECT CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI
                  FROM FILIAL
                   WHERE NMFILIAL = :NMFILIAL";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getAgencias ($params) {
        $sql = "SELECT DISTINCT A.NMAGENCIA, C.CDAGENCIA
                  FROM CONTCORR C JOIN AGENCIA A
                   ON C.CDAGENCIA = A.CDAGENCIA
                    WHERE C.CDEMPRESA = :CDEMPRESA
                    AND C.NRORG = A.NRORG
                     AND A.CDBANCO = :CDBANCO
                     AND C.NRORG = :NRORG
                  ORDER BY A.NMAGENCIA";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getContas ($params) {
        $sql = "SELECT DISTINCT CDCONTCORR, DSCONTCORR, CDREDUCONT
                    FROM CONTCORR
                    WHERE CDEMPRESA = :CDEMPRESA
                      AND CDBANCO = :CDBANCO
                      AND CDAGENCIA = :CDAGENCIA 
                      AND NRORG = :NRORG 
                      ORDER BY CDCONTCORR";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    
    public function saveFinancEstabelec ($params) {
        $sql = "UPDATE PARAMFINESTADQ 
                  SET CDEMPRESA         = :CDEMPRESA,
                      CDINSCESTA        = :CDINSCESTA,
                      CDINSCMUNI        = :CDINSCMUNI,
                      CDSERIE           = :CDSERIE,
                      CDREDUCONT        = :CDREDUCONT, 
                      CDTPCTRECEB       = :CDTPCTRECEB,
                      CDAJUCTREC        = :CDAJUCTREC, 
                      CDTPDEBIBANC      = :CDTPDEBIBANC, 
                      CDTPCREDBANC      = :CDTPCREDBANC,
                      CDTPDBDEBGER      = :CDTPDBDEBGER,
                      CDTPDEBALUGUEL    = :CDTPDEBALUGUEL,
                      CDTIPOOPER        = :CDTIPOOPER,
                      IDATIVO           = :IDATIVO, 
                      DTULTATU          = :DTULTATU, 
                      CDOPERULTATU      = :CDOPERULTATU,  
                      IDENTRSAIDOP      = :IDENTRSAIDOP
                WHERE NRORG = :NRORG
                  AND NRESTABELEC = :NRESTABELEC
                  AND NRADQUIRENTE = :NRADQUIRENTE"; 
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function insertLogEstFinac ($params) {
        $sql = "INSERT INTO LOGFINESTADQ
                  (NRLOGFINESTADQ, NRESTABELEC, NRADQUIRENTE, DTOPERACAO, CDOPERADOR, IDTIPO, DSINFANTIGA, DSINFNOVA)
                VALUES
                  (:NRLOGFINESTADQ, :NRESTABELEC, :NRADQUIRENTE, TO_CHAR(SYSDATE, 'DD/MM/YYYY HH24:MI:SS'), :CDOPERADOR, :IDTIPO, :DSINFANTIGA, :DSINFNOVA)";                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function filterFinacEstRow ($params) {
        $sql = "SELECT P.NRPARAMFINESTADQ, P.NRESTABELEC , E.NMESTABELEC , P.NRADQUIRENTE, 
                  P.CDEMPRESA, EM.NMEMPRESA, P.CDINSCESTA, P.CDINSCMUNI, P.CDSERIE, 
                  S.DSSERIE, P.CDREDUCONT, CONT.CDCONTCORR, 
                  B.NMBANCO, CONT.CDAGENCIA, CONT.CDBANCO, P.CDTPCTRECEB, 
                  TCR.DSTPCTRECEB, P.CDAJUCTREC, TAR.DSAJUCTREC, 
                  P.CDTPDEBIBANC, TDB.DSTPDEBIBANC, P.CDTPDBDEBGER, TD.DSTPDEBIBANC DSTPDBDEBGER,
                  P.CDCLIENTE, C.NMRAZSOCCLIE, P.NRORG, P.CDTIPOOPER, P.IDENTRSAIDOP, TOA.NMTIPOOPER,
                  B.CDPICTCONT, B.CDPICTAGEN, P.CDTPCREDBANC
                FROM PARAMFINESTADQ P LEFT JOIN CONTCORR CONT
                    ON P.CDREDUCONT = CONT.CDREDUCONT
                  LEFT JOIN TIPOCTRECEBER TCR
                    ON P.CDTPCTRECEB = TCR.CDTPCTRECEB
                  LEFT JOIN TIPOAJRECEBER TAR
                    ON P.CDAJUCTREC = TAR.CDAJUCTREC
                  LEFT JOIN TPDEBIBANC TDB
                    ON P.CDTPDEBIBANC = TDB.CDTPDEBIBANC
                  LEFT JOIN TPDEBIBANC TD
                    ON P.CDTPDBDEBGER = TD.CDTPDEBIBANC
                  LEFT JOIN TIPOOPERAC TOA
                    ON P.CDTIPOOPER = TOA.CDTIPOOPER
                    AND P.IDENTRSAIDOP = TOA.IDENTRSAIDOP
                  LEFT JOIN SERIENF S
                    ON P.CDSERIE = S.CDSERIE
                    AND P.CDINSCMUNI = S.CDINSCMUNI
                    AND P.CDINSCESTA = S.CDINSCESTA
                  LEFT JOIN CLIENTE C
                    ON P.CDCLIENTE = C.CDCLIENTE
                  LEFT JOIN BANCO B
                    ON CONT.CDBANCO = B.CDBANCO
                  LEFT JOIN TPCREDBANC TCB
                    ON TCB.CDTPCREDBANC = P.CDTPCREDBANC, ESTABELECIMENTO E, EMPRESA EM
                WHERE P.NRORG = :NRORG
                   AND P.NRESTABELEC = :NRESTABELEC
                  AND P.NRESTABELEC = E.NRESTABELEC
                  AND P.CDEMPRESA = EM.CDEMPRESA
                ORDER BY P.NRESTABELEC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getBancoMasks ($params) {
        $sql = "SELECT CDPICTAGEN, CDPICTCONT
                FROM BANCO
                WHERE CDBANCO = :CDBANCO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getCdreducont ($params) {
        $sql = "SELECT CDREDUCONT FROM CONTCORR
                WHERE NRORG  = :NRORG 
                 AND CDBANCO    = :CDBANCO 
                 AND CDAGENCIA  = :CDAGENCIA
                 AND CDCONTCORR = :CDCONTCORR
                 AND CDEMPRESA  = :CDEMPRESA";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getCdEmpresa ($params) {
        $sql = "SELECT CDEMPRESA, NRINSJURFILI
                FROM FILIAL
                WHERE NRORG = :NRORG
                  AND CDFILIAL = :CDFILIAL";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll()[0];
    }
    
    public function getAcquirersAut($row){
        $sql = "SELECT DAT.NRADQUIRENTE, DAT.NMADQUIRENTE, DAT.CDADQUIRENTE||' - '||DAT.NMADQUIRENTE AS LABELPRODUTOADQ, 
         N FROM 
               (SELECT D.*, ROWNUM as N 
                FROM 
                     (SELECT NRADQUIRENTE, NMADQUIRENTE, CDADQUIRENTE, CDADQUIRENTE||' - '||NMADQUIRENTE AS LABELADQUIRENTE 
                       FROM ADQUIRENTE 
                       WHERE UPPER (CDADQUIRENTE||' - '||NMADQUIRENTE) LIKE UPPER (:LABELADQUIRENTE)
                        AND IDATIVO = 'S'
                       ) D ) DAT 
            ORDER BY LABELPRODUTOADQ";

        $std = $this->connection->prepare($sql);
        $std->execute($row);
        return $std->fetchAll();
    }
    
    public function getProductsAut($row){
        $sql = "SELECT DAT.NRPRODUTOADQ, DAT.NMPRODUTOADQ, DAT.CDPRODUTOADQ||' - '||DAT.NMPRODUTOADQ AS LABELPRODUTOADQ, 
         N FROM 
               (SELECT D.*, ROWNUM as N 
                FROM 
                     (SELECT NRPRODUTOADQ, NMPRODUTOADQ, CDPRODUTOADQ, CDPRODUTOADQ||' - '||NMPRODUTOADQ AS LABELPRODUTOADQ,
                      NRORG
                       FROM PRODUTOADQ 
                       WHERE UPPER (CDPRODUTOADQ||' - '||NMPRODUTOADQ) LIKE UPPER ('%'||:LABELPRODUTOADQ||'%')
                        AND IDATIVO = 'S'
                       ) D ) DAT
            ORDER BY NMPRODUTOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
        return $std->fetchAll();
    }
}