<?php 

namespace WebServiceCall\Repository\DB;

class ProdutoAdq extends ABaseRepo {
    private const PRODUTOADQ_NOT_FOUND_BY_CODE = 'SALE ->  Não foi encontrado produto para a filtragem. CDPRODUTOADQ ->  ';
    private const PRODUTOADQ_NOT_FOUND_BY_TYPE = 'SALE ->  Não foi encontrado produto para a filtragem. TipoProduto ->  ';

    // Retorna o sequencial do produto baseado no campo de código do produto do relatório.
    public function getNexProdutoID($cdProduto) {
        $params = array(
            ':CDPRODUTOADQ' => $cdProduto,
        );

        $nextProdutoID = $this->conn->fetchRow(self::GET_PRODUTOADQ_BY_CODE, $params, [], true);

        if (!$nextProdutoID) {
            throw new \Exception(self::PRODUTOADQ_NOT_FOUND_BY_CODE . $cdProduto . ' ');
        }
        
        return $nextProdutoID;
    }

    public function getProdutoAdqByTipoProduto($tipoProduto) {
        $params = array(
            ':TIPOPRODUTO' => $tipoProduto,
        );

        $produtoAdq = $this->conn->fetchAssoc(self::GET_PRODUTOADQ_BY_TIPO_PRODUTO, $params, [], true);
        $nextProdutoID = $produtoAdq['NRPRODUTOADQ'];

        if (!$nextProdutoID) {
            throw new \Exception(self::PRODUTOADQ_NOT_FOUND_BY_TYPE . $tipoProduto);
        }
        return $produtoAdq;
    }

    private const GET_PRODUTOADQ_BY_CODE = "
         SELECT NRPRODUTOADQ 
           FROM PRODUTOADQ
          WHERE CDPRODUTOADQ = :CDPRODUTOADQ
    ";
          
    private const GET_PRODUTOADQ_BY_TIPO_PRODUTO = "
        SELECT NRPRODUTOADQ, CDPRODUTOADQ 
          FROM PRODUTOADQ
         WHERE NMPRODUTOADQ = REPLACE(UPPER(':TIPOPRODUTO'), 'É', 'E')
    ";
    
}